"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var _spying_1 = require("../_spying");
var RestorableFunctionSpy = (function (_super) {
    __extends(RestorableFunctionSpy, _super);
    function RestorableFunctionSpy(target, functionName) {
        _super.call(this);
        this._originalFunction = target[functionName];
        this.context = target;
        this._functionName = functionName;
        this._target = target;
        target[functionName] = this.call.bind(this);
        // expose spy's calls on function
        target[functionName].calls = this.calls;
        // expose spy's restore function
        target[functionName].restore = this.restore.bind(this);
    }
    RestorableFunctionSpy.prototype.restore = function () {
        this._target[this._functionName] = this._originalFunction;
    };
    RestorableFunctionSpy.prototype.andCallThrough = function () {
        this.isStubbed = false;
    };
    RestorableFunctionSpy.prototype.andStub = function () {
        this.isStubbed = true;
    };
    RestorableFunctionSpy.prototype.call = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        var returnValue = _super.prototype.call.apply(this, args);
        if (!this.isStubbed && !this.hasReturnValue) {
            return this._originalFunction.apply(this.context, args);
        }
        return returnValue;
    };
    return RestorableFunctionSpy;
}(_spying_1.FunctionSpy));
exports.RestorableFunctionSpy = RestorableFunctionSpy;
//# sourceMappingURL=restorable-function-spy.js.map