"use strict";
var Promise = (function () {
    function Promise(asyncFunction) {
        var _this = this;
        this._resolveCallback = function () { };
        this._rejectCallback = function () { };
        setTimeout(function () {
            try {
                asyncFunction(_this._resolve.bind(_this), _this._reject.bind(_this));
            }
            catch (error) {
                _this._rejectCallback(error);
            }
        });
    }
    Promise.prototype._resolve = function (resolvedValue) {
        try {
            this._resolveCallback(resolvedValue);
        }
        catch (error) {
            this._reject(error);
        }
    };
    Promise.prototype._reject = function (error) {
        this._rejectCallback(error);
    };
    Promise.prototype.then = function (callback) {
        this._resolveCallback = callback;
        return this;
    };
    Promise.prototype.catch = function (callback) {
        this._rejectCallback = callback;
        return this;
    };
    return Promise;
}());
exports.Promise = Promise;
//# sourceMappingURL=promise.js.map